lastMouseX = 0
lastMouseY = 0

# LISTES DE STOCKAGE DES DONNEES LORS DU DESSIN A LA MAIN
t = 0  # timer
speed = 2.5
time = []
X =[]
Y =[]

# LISTE DES COEFFICIENTS DE FOURRIER
nbCoeff = 35
AX = []
AY = []
BX = []
BY = []

# timers pour la courbe paramétrée
tbis     = 0
tbisLast = 0

drawTrigo = False # Si False on peut dessiner sur la feuille blanche

def Eraze(liste):
    while len(liste)>0:
        liste.remove(liste[0])

def RefreshDrawing():
    global drawtrigo, t,tbis,tbisLast,canvas,canvasTrigo,time,X,Y,AX,AY,BX,BY, canvas, canvasTrigo
    drawTrigo = False
    t = 0
    tbis = 0
    tbislast=0
    canvas.beginDraw()
    canvas.clear()
    canvas.endDraw()
    canvasTrigo.beginDraw()
    canvasTrigo.clear() 
    canvasTrigo.endDraw()
    Eraze(time)
    Eraze(X)
    Eraze(Y)
    Eraze(AX)
    Eraze(AY)
    Eraze(BX)
    Eraze(BY)

def AB0(f,T):
    a = 0
    for i in range(T):
        a = a + f[i]
    a= a/T
    return a

def A(f,n,T):
    a = 0
    w = 2*PI/T
    for i in range(T):
        a = a +f[i]*cos(n*(i+1)*w)
    a  =2*a/T
    return a  

def B(f,n,T):
    b = 0
    w = 2*PI/T
    for i in range(T):
        b = b + f[i]*sin(n*(i+1)*w)
    b = 2*b/T
    return b


def Xtrigo(t,T):
    global AX,BX
    w = 2*PI/T
    res = AX[0]
    for n in range(1,len(AX)):
        res = res + AX[n]*cos(t*w*n)
    for n in range(len(BX)):
        res = res + BX[n]*sin(t*w*(n+1))        
    return res       
        
def Ytrigo(t,T):
    global AY,BY
    w = 2*PI/T
    res = AY[0]
    for n in range(1,len(AY)):
        res = res + AY[n]*cos(t*w*n)
    for n in range(len(BY)):
        res = res + BY[n]*sin(t*w*(n+1))        
    return res  

def BeginDrawing():
    global AX,AY,BX,BY,time, nbCoeff, drawTrigo,X,Y
    T = len(time)
    
    
    # ON DOUBLE LA LISTE DU TEMPS
    timeSuite =[]
    for t in time:
        timeSuite.append(T + t)
    time = time + timeSuite
    T = len(time)
    
    #on symétrise la liste des X et des Y
    X_Suite= [ x for x in X]
    X_Suite.reverse()
    X=X+X_Suite
    Y_Suite= [ y for y in Y]
    Y_Suite.reverse()
    Y=Y+Y_Suite

    
    AX.append(AB0(X,T))
    AY.append(AB0(Y,T))
    for n in range(1,nbCoeff):
        AX.append(A(X,n,T))
        AY.append(A(Y,n,T))
        #ON DEGAGE TOUS LES COEFFICIENTS EN SINUS CAR LES FONCTIONS X ET Y SONT PAIRES
         #BX.append(B(X,n,T))
         #BY.append(B(Y,n,T))
    drawTrigo = True
        
        

def DrawFeuilles():
    fill(255)
    rect(50,50,500,500)
    fill(0)
    rect(650,50,500,500)
    
def IsInFeuilleBlanche(sourisX,sourisY):
        if sourisX>50 and sourisX<50+500 and sourisY > 50 and sourisY<50+500:
            return True
        return False
    
def ArrondiCoeff(liste):
    for k in range(len(liste)):
        if liste[k] - floor(liste[k]) < floor(liste[k])+1 - liste[k] :
            liste[k] = floor(liste[k])
        else:
            liste[k] = floor(liste[k]) + 1
                
#===================================================================================================
#                 PROGRAMME PRINCIPAL
#===================================================================================================

def setup():
    size(1200,650)
    global canvas,canvasTrigo,img
    canvas = createGraphics(600,650)
    canvasTrigo =  createGraphics(600,650)
    #img = loadImage("Capture.JPG")

   
def draw():
    global nbCoeff,tbis,tbisLast,lastMouseX,lastMouseY,drawTrigo, time
    lastMouseX = mouseX
    lastMouseY = mouseY
    background(70)
    DrawFeuilles()
    #image(img,50,50)
    image(canvas,0,0)
    image(canvasTrigo,600,0)  
    
    if drawTrigo == False:
        fill(255)
        text("REFRESH = 'espace'         DRAW = 'D'         NB COEFF DE FOURIER = 'UP/DOWN'",50,30)  
        text("NB COEFF DE FOURIER = " + str(nbCoeff),50,600)
    else:
        tbisLast = tbis
        tbis = tbis + speed
        T=len(time)
        canvasTrigo.beginDraw()
        canvasTrigo.stroke(255)
        canvasTrigo.line(Xtrigo(tbis,T),Ytrigo(tbis,T),Xtrigo(tbisLast,T),Ytrigo(tbisLast,T))
        canvasTrigo.endDraw()    
        if tbis > T/2:
            tbis = 0
            tbisLast = 0
            drawTrigo = False
            # ON ECRIT LES EQUATIONS PARAMETRIQUES DANS LA CONSOLE AVANT DE TOUT EFFACER===================
            w= 2*PI/T
            RES_X = "X(t) = "
            RES_Y = "Y(t) = "
            print("============================================================================")
            print("pulsation : w = "+str(w))
            print ("periode :  T = " + str(T)) 
            ArrondiCoeff(AX)
            ArrondiCoeff(AY)
            RES_X += str(AX[0])
            RES_Y += str(AY[0])
            
            for k in range(1,len(AX)):
                if AX[k] <0 :
                    RES_X = RES_X + str(AX[k]) + "cos("+str(k)+"wt)"
                elif AX[k]>0:
                     RES_X = RES_X + "+"+str(AX[k]) + "cos("+str(k)+"wt)"
            
            for k in range(1,len(AY)):
                if AY[k] <0 :
                    RES_Y = RES_Y + str(AY[k]) + "cos("+str(k)+"wt)"
                elif AY[k]>0:
                     RES_Y = RES_Y + "+"+str(AY[k]) + "cos("+str(k)+"wt)"
                     
            print(RES_X)
            print(RES_Y)
            # ON EFFACE TOUT==========================================
            Eraze(time)
            Eraze(X)
            Eraze(Y)
            Eraze(AX)
            Eraze(AY)
            Eraze(BX)
            Eraze(BY)

 

def mouseDragged():
    if IsInFeuilleBlanche(mouseX,mouseY):
        global t,time,X,Y,canvas,lastMouseX,lastMouseY
   
        time.append(t)
        X.append(mouseX)
        Y.append(mouseY)
    
        t=t+1
        canvas.beginDraw()
        canvas.stroke(0)
        canvas.line(mouseX,mouseY,lastMouseX,lastMouseY)
        canvas.endDraw()
        lastMouseX = mouseX
        lastMouseY = mouseY
        
  
def keyReleased():
    global nbCoeff
    if drawTrigo == False:
        if keyCode == UP :
            nbCoeff = nbCoeff+1
        if keyCode == DOWN and nbCoeff>0:
            nbCoeff = nbCoeff-1
        
        if key == " ":  
            RefreshDrawing()  
        if key == "d":
            BeginDrawing()  
